this.name			= "Tch_Gravitation_for_vasig.oxp";
this.author			= "Vladimir P. Tch";
this.copyright		= "Creative Commons Attribution-Noncommercial-Share Alike 3.0 Unported License";
this.licence		= "CC BY-NC-SA 3.0 (Creative Commons Attribution-Noncommercial-Share Alike 3.0 Unported License)";
this.description	= "Гравитация (только режим орбитального полёта вместе со спутниками на орбитах)";
this.version		= "1.0.0 (2013-12-29)";

//--- Задаём коэфф. ускоренного перемещения по орбите корабля игрока, фактически это множитель орбитальной скорости. Нужен для того, чтобы не затягивать игровой процесс.
this.nKoeff_Time_Circle_Orbit = 5;



this.func_ModeFly = function(){
	if ((global.Tch_aSputniks) && (global.Tch_aSputniks.length > 0)){
		this.func_Sputniks_Orbits_01();
	}
	if (player.ship.isValid){
		if (global.sSwitch_Circle_Orbit){
			this.func_Model_Circle_Orbit_01();
		}
	}
}
this.func_Sputniks_Orbits_01 = function (){
	for ( var mt1 = 0; mt1 < global.Tch_aSputniks.length; mt1++){
		if (global.Tch_aSputniks[mt1][0] != "отсутствует"){
			if (global.Tch_aSputniks[mt1][1] != "отсутствует"){
				if (global.Tch_aSputniks[mt1][1].isValid){
					global.Tch_aSputniks[mt1][4] = global.Tch_aSputniks[mt1][4].rotateBy( global.Tch_aSputniks[mt1][14] );
					global.Tch_aSputniks[mt1][3] = global.Tch_aSputniks[mt1][0].add( global.Tch_aSputniks[mt1][4] );
					global.Tch_aSputniks[mt1][1].position = global.Tch_aSputniks[mt1][3];
					globfunc_Orientation_toPosition( global.Tch_aSputniks[mt1][1], global.Tch_aSputniks[mt1][2] );
				}
			}
		}
	}
}
this.func_Model_Circle_Orbit_01 = function (){
	globfunc_PlayerShip_Planets();
	globfunc_PlayerShip_Planets_Sort_Koeff();
	if (global.bEvent_Start_Circle_Orbit){
		global.bEvent_Start_Circle_Orbit = false;
		var nAverage_Density_Planet = 5000;
		if (global.aKoef_Planet[4].isMainPlanet){
			nAverage_Density_Planet = 5000;
		}
		else {
			if (global.aKoef_Planet[4].hasAtmosphere){
				if (global.aKoef_Planet[4].radius < 10E4){
					nAverage_Density_Planet = 5000;
				}
				else {
					nAverage_Density_Planet = 2000;
				}
			}
			else {
				nAverage_Density_Planet = 4000;
			}
		}
		this.nVelocity_Circle_Orbit = 0.00000167 * Math.sqrt(( nAverage_Density_Planet * global.aKoef_Planet[4].radius * global.aKoef_Planet[4].radius * global.aKoef_Planet[4].radius ) / global.aKoef_Planet[2] );
		this.nPeriod_Circle_Orbit = (( 6.283 * global.aKoef_Planet[2] ) / ( this.nVelocity_Circle_Orbit * 10 ));
		this.vPlayer_VectorOrbit = global.aKoef_Planet[3];
		var VectorAxis = player.ship.heading.cross( this.vPlayer_VectorOrbit ).direction();
		var nVelocityAngular_Circle_Orbit = ( this.nVelocity_Circle_Orbit * 10 )/ global.aKoef_Planet[2];
		var nAngularElement_Circle_Orbit = nVelocityAngular_Circle_Orbit * 0.25;
		this.nAngle = nAngularElement_Circle_Orbit * this.nKoeff_Time_Circle_Orbit;
		this.nPlayer_Angle = 0;
		var ncos = Math.cos( this.nAngle/2 );
		var nsin = Math.sin( this.nAngle/2 );
		this.Player_Quaternion = new Quaternion( ncos, VectorAxis.x * nsin, VectorAxis.y * nsin, VectorAxis.z * nsin );
	}
	this.nPlayer_Angle += this.nAngle;
	this.vPlayer_VectorOrbit = this.vPlayer_VectorOrbit.rotateBy( this.Player_Quaternion );
	player.ship.position = global.aKoef_Planet[4].position.add( this.vPlayer_VectorOrbit );
	var vNew_Player_Heading = player.ship.heading.rotateBy( this.Player_Quaternion );
	var vPlayer_Cross = player.ship.heading.cross( vNew_Player_Heading ).direction();
	player.ship.orientation = player.ship.orientation.rotate( vPlayer_Cross, -this.nAngle );
	if (global.sSwitch_Display_Circle_Orbit){
		this.mt1 = this.mt1 + 1;
		if (this.mt1 == 3){
			this.mt1 = 0;
			player.consoleMessage( "\n", 2 );
			player.consoleMessage( "\t", 2 );
			player.consoleMessage( "\n", 2 );
			player.consoleMessage( "\t", 2 );
			player.consoleMessage( "\n", 2 );
			player.consoleMessage( "\t", 2 );
			player.consoleMessage( "            Высота, км:  "     + global.nKoef_DistanceTo_SurfacePlanet, 2 );
			player.consoleMessage( "Угол поворота, град.:  "   + ( Math.round(( this.nPlayer_Angle / Math.PI ) * 18000 ) / 100 ), 2 );
			player.consoleMessage( "Орбит.скорость, км/с: " + ( Math.round( this.nVelocity_Circle_Orbit * 10 ) / 10 ) + "     период обр., мин: " + ( Math.round( this.nPeriod_Circle_Orbit / 6 ) / 10 ), 2 );
		}
	}
}
this.startUp = function(){
	this.mt1 = 0;
	global.sSwitch_Circle_Orbit = false;
	global.sSwitch_Display_Circle_Orbit = true;
	global.bEvent_Start_Circle_Orbit = true;
}
this.shipLaunchedFromStation = function(){
	if (this.timer_Position_PlayerShip){
		this.timer_Position_PlayerShip.start();
	}
	else{
		this.timer_Position_PlayerShip = new Timer(this, this.func_ModeFly, 5, 0.1);
	}
}
this.shipWillDockWithStation = function(station){
	if (this.timer_Position_PlayerShip && this.timer_Position_PlayerShip.isRunning){
		this.timer_Position_PlayerShip.stop();
	}
}
this.playerBoughtEquipment = function ( equipment ){
	if (equipment == "EQ_TCH_ORBIT_FLY"){
		log( this.name, "\n\n"
		+ "Куплено оборудование для орбитальных полётов " + equipment + "\n"
		+ globfunc_Equipment_on_ShipPlayer( "подробно" ) + "\n"
		);
	}
	else if (equipment == "EQ_TCH_ORBIT_FLY_REMOVAL"){
		player.ship.removeEquipment( "EQ_TCH_ORBIT_FLY" );
		player.ship.removeEquipment( "EQ_TCH_ORBIT_FLY_REMOVAL" );
		player.credits += (EquipmentInfo.infoForKey( "EQ_TCH_ORBIT_FLY" ).price * 0.1 * 0.75);
		log( this.name, "\n\n"
		+ "Демонтировано и продано оборудование для орбитальных полётов " + equipment + "\n"
		+ globfunc_Equipment_on_ShipPlayer( "подробно" ) + "\n"
		);
	}
}
this.equipmentDamaged = function ( equipment ){
	if (equipment == "EQ_TCH_ORBIT_FLY"){
		log( this.name, "\n\n"
		+ "Повреждено оборудование для орбитальных полётов " + equipment + "." + "\n"
		+ globfunc_Equipment_on_ShipPlayer( "подробно" ) + "\n"
		);
	}
}
this.equipmentDestroyed = function ( equipment ){
	if (equipment == "EQ_TCH_ORBIT_FLY"){
		log( this.name, "\n\n"
		+ "Полностью уничтожено оборудование для орбитальных полётов " + equipment + "." + "\n"
		+ globfunc_Equipment_on_ShipPlayer( "подробно" ) + "\n"
		);
	}
}
